searchNodes=[{"doc":"Utilities for dealing with Chinese characters (Hanzi) and Pinyin.This module contains several functions which deal with strings containing Han characters or Pinyin. Specifically, the following functionality is present:iex&gt; Hanyutils.to_marked_pinyin(&quot;你好&quot;) &quot;nǐhǎo&quot; iex&gt; Hanyutils.to_numbered_pinyin(&quot;你好&quot;) &quot;ni3hao3&quot; iex&gt; Hanyutils.characters?(&quot;你好&quot;) true iex&gt; Hanyutils.mark_pinyin(&quot;ni3hao3&quot;) &quot;nǐhǎo&quot; iex&gt; Hanyutils.number_pinyin(&quot;nǐhǎo&quot;) &quot;ni3hao3&quot;All of these functions are built based on the functionality found in the Hanzi and Pinyin modules. If this module does not contain the required functionality you need, it is possible it can be built manually based on the abstractions in these modules. For instance, the to_marked_pinyin function could be implemented as follows:def to_marked_pinyin(string) do string |&gt; Hanzi.read() |&gt; Hanzi.to_pinyin() |&gt; Pinyin.marked() endPlease refer to the documentation of the Hanzi and Pinyin modules for more information.","ref":"Hanyutils.html","title":"Hanyutils","type":"module"},{"doc":"See Hanzi.characters?/1.","ref":"Hanyutils.html#characters?/1","title":"Hanyutils.characters?/1","type":"function"},{"doc":"Convert a string with numbered Pinyin to marked Pinyin.Parses the input using Pinyin.read!/1 (in :words mode), and converts the result with Pinyin.marked/1. Please refer to the documentation of Pinyin.read/2 if you required details on how the input is parsed.Examplesiex&gt; Hanyutils.mark_pinyin(&quot;ni3hǎo&quot;) &quot;nǐhǎo&quot;","ref":"Hanyutils.html#mark_pinyin/1","title":"Hanyutils.mark_pinyin/1","type":"function"},{"doc":"Convert a string with marked Pinyin to numbered Pinyin.Parses the input using Pinyin.read!/1 (in :words mode), and converts the result with Pinyin.numbered/1. Please refer to the documentation of Pinyin.read/2 if you required details on how the input is parsed. It is worth noting that the Pinyin.read/2 parser is sensitive to the location of the tone marker.Examplesiex&gt; Hanyutils.number_pinyin(&quot;ni3hǎo&quot;) &quot;ni3hao3&quot;","ref":"Hanyutils.html#number_pinyin/1","title":"Hanyutils.number_pinyin/1","type":"function"},{"doc":"Convert a string containing Han characters to marked Pinyin.For more information about converter, please refer to Hanzi.to_pinyin/2.Examplesiex&gt; Hanyutils.to_marked_pinyin(&quot;你好&quot;) &quot;nǐhǎo&quot; iex&gt; Hanyutils.to_marked_pinyin(&quot;你好&quot;, &amp;Hanzi.all_pronunciations/1) &quot;nǐ[ hǎo | hào ]&quot;","ref":"Hanyutils.html#to_marked_pinyin/2","title":"Hanyutils.to_marked_pinyin/2","type":"function"},{"doc":"Convert a string containing Han characters to numbered Pinyin.For more information about converter, please refer to Hanzi.to_pinyin/2.Examplesiex&gt; Hanyutils.to_numbered_pinyin(&quot;你好&quot;) &quot;ni3hao3&quot; iex&gt; Hanyutils.to_numbered_pinyin(&quot;你好&quot;, &amp;Hanzi.all_pronunciations/1) &quot;ni3[ hao3 | hao4 ]&quot;","ref":"Hanyutils.html#to_numbered_pinyin/2","title":"Hanyutils.to_numbered_pinyin/2","type":"function"},{"doc":"Han/Chinese character (汉字) utilities and conversion to Pinyin lists.The main goal of this module is to convert strings containing Han characters into a Pinyin.pinyin_list/0. In turn, such a list can be formatted by the functions present in the Pinyin module (i.e. Pinyin.marked/1 or Pinyin.numbered/1).A string of Han characters can be read with read/1 or sigil_h/2. These functions both return a list containing strings mixed with Hanzi.t/0 structs. Such a list can be converted into a Pinyin.pinyin_list/0 through the use of to_pinyin/2. Users with more esoteric use cases can directly modify the Hanzi.t/0 inside the hanzi_list/0.to_pinyin/2 and convertersSince a given Hanzi may have different valid pronunciations, to_pinyin/2 accepts a second argument that determines how a given Hanzi.t/0 is converted into a Pinyin.pinyin_list/0. This second argument is called a converter. This module includes some standard converters. Please refer to the documentation of to_pinyin/2 for more information.Data sourceThe results of the functions offered by this module are all ultimately derived from the data contained in the Unihan_Readings.txt file of the Unicode Han Database. t/0 contains additional information about the available information.","ref":"Hanzi.html","title":"Hanzi","type":"module"},{"doc":"Converter that returns all pronunciations of a character or the most common.If only a single pronunciation is available, it is returned, otherwise, all possible pronunciations are returned. When all possible pronunciations are returned, left, mid and right determine how the alternatives are separated. left is positioned before the first pronunciation in the list, right is positioned after the last pronunciation, mid is positioned between all the other pronunciations.Examplesiex&gt; Hanzi.all_pronunciations(~h/你/s) [%Pinyin{word: &quot;ni&quot;, tone: 3}] iex&gt; Hanzi.all_pronunciations(~h/㓎/s) [&quot;[ &quot;, %Pinyin{word: &quot;qin&quot;, tone: 1}, &quot; | &quot;, %Pinyin{word: &quot;qin&quot;, tone: 4}, &quot; | &quot;, %Pinyin{word: &quot;qin&quot;, tone: 3}, &quot; ]&quot;] iex&gt; Hanzi.all_pronunciations(~h/㓎/s, &quot;&quot;, &quot;&quot;, &quot;&quot;) [&quot;&quot;, %Pinyin{word: &quot;qin&quot;, tone: 1}, &quot;&quot;, %Pinyin{word: &quot;qin&quot;, tone: 4}, &quot;&quot;, %Pinyin{word: &quot;qin&quot;, tone: 3}, &quot;&quot;]","ref":"Hanzi.html#all_pronunciations/4","title":"Hanzi.all_pronunciations/4","type":"function"},{"doc":"Check if a single character is a valid Han character.Examplesiex&gt; Hanzi.character?(&quot;你&quot;) true iex&gt; Hanzi.character?(&quot;x&quot;) false iex&gt; Hanzi.character?(&quot;你好&quot;) false","ref":"Hanzi.html#character?/1","title":"Hanzi.character?/1","type":"function"},{"doc":"Convert a Hanzi list to a string of characters.This function extracts the character of each Hanzi.t/0 in lst. Normal strings in the list not modified. After converting the Hanzi in the list to characters, the list is joined with Enum.join/2. The joiner argument will be passed as the joiner to Enum.join/2.Examplesiex&gt; characters(~h/你好/) &quot;你好&quot; iex&gt; characters(~h/你hello/) &quot;你hello&quot; iex&gt; characters(~h/你好/, &quot;;&quot;) &quot;你;好&quot; iex&gt; characters(~h/你hello/, &quot;;&quot;) &quot;你;hello&quot;","ref":"Hanzi.html#characters/2","title":"Hanzi.characters/2","type":"function"},{"doc":"Verify if a list or string contains only characters.Note that whitespace is not counted as a character.Examplesiex&gt; Hanzi.characters?([&quot;你&quot;, &quot;好&quot;]) true iex&gt; Hanzi.characters?([&quot;你&quot;, &quot;boo&quot;, &quot;好&quot;]) false iex&gt; Hanzi.characters?(&quot;你好&quot;) true iex&gt; Hanzi.characters?(&quot;你 好&quot;) false","ref":"Hanzi.html#characters?/1","title":"Hanzi.characters?/1","type":"function"},{"doc":"Converter that retrieves the most common pronunciation of a Hanzi.t/0.The additional argument specifies if the most common pronunciation for mainland China or Taiwan is retrieved.Examplesiex&gt; Hanzi.common_pronunciation(~h/你/s) [%Pinyin{word: &quot;ni&quot;, tone: 3}] iex&gt; Hanzi.common_pronunciation(~h/你/s, :cn) [%Pinyin{word: &quot;ni&quot;, tone: 3}] iex&gt; Hanzi.common_pronunciation(~h/你/s, :tw) [%Pinyin{word: &quot;ni&quot;, tone: 3}] iex&gt; Hanzi.common_pronunciation(~h/万/s) [%Pinyin{word: &quot;wan&quot;, tone: 4}] iex&gt; Hanzi.common_pronunciation(~h/万/s, :cn) [%Pinyin{word: &quot;wan&quot;, tone: 4}] iex&gt; Hanzi.common_pronunciation(~h/万/s, :tw) [%Pinyin{word: &quot;mo&quot;, tone: 4}]","ref":"Hanzi.html#common_pronunciation/2","title":"Hanzi.common_pronunciation/2","type":"function"},{"doc":"Obtain the Hanzi.t/0 struct for a character.Note that this only works on a single character.Examplesiex&gt; Hanzi.from_character(&quot;你&quot;) %Hanzi{char: &quot;你&quot;, pron: %Pinyin{word: &quot;ni&quot;, tone: 3}, pron_tw: nil, alt: []} iex&gt; Hanzi.from_character(&quot;x&quot;) nil iex&gt; Hanzi.from_character(&quot;你好&quot;) nil","ref":"Hanzi.html#from_character/1","title":"Hanzi.from_character/1","type":"function"},{"doc":"Read a string and convert it into a list of strings and Hanzi.t/0 structs.This function reads a string containing characters mixed with normal text. The output of this function is a list of strings and Hanzi structs.The input string may contain any character. Any character in the string that is recognised as a Han character (by character?/1) is returned as a Hanzi.t/0 in the returned list. Any other character in the input is returned unmodified.Examplesiex&gt; Hanzi.read(&quot;你好&quot;) [%Hanzi{char: &quot;你&quot;, pron: %Pinyin{word: &quot;ni&quot;, tone: 3}}, %Hanzi{char: &quot;好&quot;, pron: %Pinyin{word: &quot;hao&quot;, tone: 3}, alt: [%Pinyin{word: &quot;hao&quot;, tone: 3}, %Pinyin{word: &quot;hao&quot;, tone: 4}]}] iex&gt; Hanzi.read(&quot;hello, 你&quot;) [&quot;hello, &quot;, %Hanzi{char: &quot;你&quot;, pron: %Pinyin{word: &quot;ni&quot;, tone: 3}}]","ref":"Hanzi.html#read/1","title":"Hanzi.read/1","type":"function"},{"doc":"Sigil to create a Hanzi list or struct.When used without any modifiers, this sigil converts ins input into a hanzi list through the use of read/1. When the s modifier is used, from_character/1 is used instead.Examplesiex&gt; ~h/hello, 你/ [&quot;hello, &quot;, %Hanzi{char: &quot;你&quot;, pron: %Pinyin{word: &quot;ni&quot;, tone: 3}}] iex&gt; ~h/你/s %Hanzi{char: &quot;你&quot;, pron: %Pinyin{word: &quot;ni&quot;, tone: 3}} iex&gt; ~h/你好/s nil","ref":"Hanzi.html#sigil_h/2","title":"Hanzi.sigil_h/2","type":"macro"},{"doc":"Convert a Hanzi list to a Pinyin list.Normal strings in the Hanzi list are returned unmodified. Every Hanzi.t() is passed as an argument to converter, which returns a Pinyin.pinyin_list/0. This list is added to the result.After calling this function, Pinyin.marked/1 or Pinyin.numbered/1 can be used to format the result.ConvertersA converter is any function that transforms a Hanzi.t/0 into a Pinyin.pinyin_list/0. In the most simple case, such a converter simply returns the most common pronunciation. In more complicated cases, such a converter returns all the possible pronunciations of a Hanzi, separated by strings.The Hanzi module includes two converters: common_pronunciation/2 and all_pronunciations/4. If no converter is specified, &amp;common_pronunciation(&amp;1, :cn) is used.If you wish to write your own converter, the functions mentioned above, and the examples below should be a good starting point.Examplesiex&gt; to_pinyin(~h/你好/) [%Pinyin{word: &quot;ni&quot;, tone: 3}, %Pinyin{word: &quot;hao&quot;, tone: 3}] iex&gt; to_pinyin(~h/二万/, &amp;common_pronunciation(&amp;1, :tw)) [%Pinyin{word: &quot;er&quot;, tone: 4}, %Pinyin{word: &quot;mo&quot;, tone: 4}] iex&gt; to_pinyin(~h/你好/, &amp;all_pronunciations/1) [%Pinyin{word: &quot;ni&quot;, tone: 3}, &quot;[ &quot;, %Pinyin{word: &quot;hao&quot;, tone: 3}, &quot; | &quot;, %Pinyin{word: &quot;hao&quot;, tone: 4}, &quot; ]&quot;] iex&gt; to_pinyin(~h/你好/, &amp;all_pronunciations(&amp;1, &quot;&quot;, &quot;&quot;, &quot;&quot;)) [%Pinyin{word: &quot;ni&quot;, tone: 3}, &quot;&quot;, %Pinyin{word: &quot;hao&quot;, tone: 3}, &quot;&quot;, %Pinyin{word: &quot;hao&quot;, tone: 4}, &quot;&quot;] iex&gt; to_pinyin(~h/你好/, fn %Hanzi{pron: p} -&gt; [p] end) [%Pinyin{word: &quot;ni&quot;, tone: 3}, %Pinyin{word: &quot;hao&quot;, tone: 3}]","ref":"Hanzi.html#to_pinyin/2","title":"Hanzi.to_pinyin/2","type":"function"},{"doc":"List of Hanzi characters mixed with plain strings.","ref":"Hanzi.html#t:hanzi_list/0","title":"Hanzi.hanzi_list/0","type":"type"},{"doc":"Representation of a single Hanzi (chinese Character).This struct contains all the information extraced from the Unihan_readings database for a given character. It contains the following fields:KeyDescriptionUnihan_Readings.txt fieldcharThe character itselfpronMost common pronunciation in pinyinkMandarinpron_twMost common pronunciation for Taiwan in PinyinkMandarinaltAll readings defined by the Hanyu Pinyin DictionarykHanyuPinyinpron and pron_twIn some rare cases, the most common reading of a hanzi is different in mainland China and in Taiwan. If this is the case, the most common mainland reading will be stored under the pron key, while the most common Taiwanese reading will be stored under the pron_tw key. When the readings are the same, pron will contain the reading while pron_tw will be nil. Note that, at the time of writing, only 38 characters out of the 41226 defined by Unihan_Readings.txt have a different reading for mainland China and Taiwan.altSome hanzi have different readings based on their exact use. When this is the case, all the possible readings of a character will stored as a list in alt.","ref":"Hanzi.html#t:t/0","title":"Hanzi.t/0","type":"type"},{"doc":"Utilities to deal with pinyin syllables and groups thereof.The main goal of this module is to provide functions to manipulate strings that contain pinyin words, which are potentially mixed with other content. Users of this module can use read/2, read!/2 or sigil_p/2 to parse a string and turn it into a pinyin_list/0. Afterwards, such a list can be converted into a &quot;numbered&quot; or a &quot;marked&quot; string. Numbered strings are created with numbered/1; in this representation, tone marks are not added to the pinyin syllable, numbers are used to indicate the tone instead. When marked/1 is used, pinyin is printed with tone marks.When a string is parsed with read/2, it is converted into a list containing strings and t/0 structs. These structs encode pinyin syllables. Users of this module generally do not need to worry about manipulating these structs directly, but they are exposed for users who want to handle pinyin using custom logic. create/2, from_marked/1 and from_numbered/1 can be used to directly create a pinyin struct for a given syllable. Like pinyin_list/0, t/0 structs can be converted to strings with numbered/1 and marked/1.","ref":"Pinyin.html","title":"Pinyin","type":"module"},{"doc":"Create a Pinyin struct (t/0) from an unmarked string and a tone numeral.This function is useful if you want to dynamically create pinyin structs. The use of this function is preferred over directly using %Pinyin{}, as this function normalises word and verifies tone is valid before the struct is created.Examplesiex&gt; Pinyin.create(&quot;ni&quot;, 3) %Pinyin{tone: 3, word: &quot;ni&quot;} iex&gt; Pinyin.create(&quot;lüe&quot;, 4) %Pinyin{tone: 4, word: &quot;lve&quot;} iex&gt; Pinyin.create(&quot;lve&quot;, 4) %Pinyin{tone: 4, word: &quot;lve&quot;} iex&gt; Pinyin.create(&quot;ni&quot;, 5) ** (FunctionClauseError) no function clause matching in Pinyin.create/2","ref":"Pinyin.html#create/2","title":"Pinyin.create/2","type":"function"},{"doc":"Create a pinyin struct (t/0) from a string with tone marks.When converting the string, the tone marker is stripped and placed in the tone field of the resulting struct. An ArgumentError is thrown if multiple tone marks are present. Therefore, this function should only be used for a single pinyin word.Examplesiex&gt; Pinyin.from_marked(&quot;nǐ&quot;) %Pinyin{tone: 3, word: &quot;ni&quot;} iex&gt; Pinyin.from_marked(&quot;nǐ&quot;) %Pinyin{tone: 3, word: &quot;ni&quot;} iex&gt; Pinyin.from_marked(&quot;nǐhǎo&quot;) ** (ArgumentError) Multiple tone marks present in &#39;nǐhǎo&#39;","ref":"Pinyin.html#from_marked/1","title":"Pinyin.from_marked/1","type":"function"},{"doc":"Create a pinyin struct (t/0) from a string with a tone number.The tone number has to be 1, 2, 3 or 4 and has to be the last element of the string. If this is not the case, an invalid pinyin struct is obtained.If the tone of the word is known upfront, the use of create/2 should be preferred, as it does not need to parse the string.Examplesiex&gt; Pinyin.from_numbered(&quot;ni3&quot;) %Pinyin{tone: 3, word: &quot;ni&quot;} iex&gt; Pinyin.from_numbered(&quot;ni5&quot;) %Pinyin{tone: 0, word: &quot;ni5&quot;} iex&gt; Pinyin.from_numbered(&quot;ni&quot;) %Pinyin{tone: 0, word: &quot;ni&quot;}","ref":"Pinyin.html#from_numbered/1","title":"Pinyin.from_numbered/1","type":"function"},{"doc":"Convert a t/0 or pinyin_list/0 to a tone-marked string.The tone-marked string consists of the pinyin word with the tone added in the correct location. It is generally used when printing pinyin. Any occurence of &quot;v&quot; is shown as &quot;ü&quot;.Examplesiex&gt; marked(~p/ni3/s) &quot;nǐ&quot; iex&gt; marked(~p/lve4/s) &quot;lüè&quot; iex&gt; marked(~p/ni3hao3/) &quot;nǐhǎo&quot; iex&gt; marked(~p/NI3HAO3/) &quot;NǏHǍO&quot; iex&gt; marked(~p/Ni3hao3, how are you?/w) &quot;Nǐhǎo, how are you?&quot;","ref":"Pinyin.html#marked/1","title":"Pinyin.marked/1","type":"function"},{"doc":"Convert a t/0 or pinyin_list/0 to a numbered version.The numbered version consists of the word without tone markings followed by the number of the tone. It is often used when typing pinyin manually. Any occurence of &quot;ü&quot; is shown as &quot;v&quot;. Non-pinyin text is not modified.Examplesiex&gt; numbered(~p/nǐ/s) &quot;ni3&quot; iex&gt; numbered(~p/lüè/s) &quot;lve4&quot; iex&gt; numbered(~p/nǐhǎo/) &quot;ni3hao3&quot; iex&gt; numbered(~p/NǏHǍO/) &quot;NI3HAO3&quot; iex&gt; numbered(~p/Nǐhǎo, how are you?/w) &quot;Ni3hao3, how are you?&quot;","ref":"Pinyin.html#numbered/1","title":"Pinyin.numbered/1","type":"function"},{"doc":"Read a string and convert it into a list of string and pinyin structs.This function reads a string containing pinyin mixed with normal text. The output of this function is a list of strings and pinyin structs. White space and punctuation will be separated from other strings.The input string may contain tone-marked (e.g. &quot;nǐ&quot;) pinyin, numbered (&quot;ni3&quot;) pinyin or a mix thereof (nǐ hao3). Note that in numbered pinyin mode tone numerals must not be separated from their word. For instance, &quot;ni3&quot; will be correctly parsed as &quot;nǐ&quot;, &quot;ni 3&quot; will not. When tone marked pinyin is used the tone must be marked on the correct letter. For instance, hǎo will parse correctly, haǒ will not; we recommend the use of numbered pinyin if there is uncertainty about the location of the tone mark.Parse ModesBy default, this function only accepts strings which consists exclusively of pinyin, whitespace and puncutation. Parsing any text that cannot be interpreted as pinyin will result in an error:iex&gt; Pinyin.read(&quot;Ni3hao3!&quot;) {:ok, [%Pinyin{tone: 3, word: &quot;Ni&quot;}, %Pinyin{tone: 3, word: &quot;hao&quot;}, &quot;!&quot;]} iex&gt; Pinyin.read(&quot;Ni3hao3, hello!&quot;) {:error, &quot;hello!&quot;}This behaviour can be tweaked if pinyin mixed with regular text needs to be parsed; this can be done by passing a mode to this function. There are 3 available modes::exclusive: The default. Every character (except white space and punctuation) is interpreted as pinyin. If this is not possible, an error is returned.:words: Any word (i.e. a continuous part of the string that does not contain whitespace or punctuation) is either interpreted as a sequence of pinyin syllables or as non-pinyin text. If a word contains any characters that cannot be interpreted as pinyin, the whole word is considered to be non-pinyin text. This mode does not return errors.:mixed: Any word can contain a mixture of pinyin and non-pinyin characters. The read function will interpret anything it can interpret as pinyin as pinyin and leaves the other text unmodified. This is mainly useful to mix characters and pinyin. It is not recommended to use this mode to mix pinyin and normal text. This mode does not return errors.The following examples show the use of all three modes:iex&gt; Pinyin.read(&quot;Ni3hao3!&quot;, :exclusive) {:ok, [%Pinyin{tone: 3, word: &quot;Ni&quot;}, %Pinyin{tone: 3, word: &quot;hao&quot;}, &quot;!&quot;]} iex&gt; Pinyin.read(&quot;Ni3hao3, hello!&quot;, :exclusive) {:error, &quot;hello!&quot;} iex&gt; Pinyin.read(&quot;Ni3好hao3, hello!&quot;, :exclusive) {:error, &quot;Ni3好hao3, hello!&quot;} iex&gt; Pinyin.read(&quot;Ni3hao3!&quot;, :words) {:ok, [%Pinyin{tone: 3, word: &quot;Ni&quot;}, %Pinyin{tone: 3, word: &quot;hao&quot;}, &quot;!&quot;]} iex&gt; Pinyin.read(&quot;Ni3hao3, hello!&quot;, :words) {:ok, [%Pinyin{tone: 3, word: &quot;Ni&quot;}, %Pinyin{tone: 3, word: &quot;hao&quot;}, &quot;, &quot;, &quot;hello&quot;, &quot;!&quot;]} iex&gt; Pinyin.read(&quot;Ni3好hao3, hello!&quot;, :words) {:ok, [&quot;Ni3好hao3&quot;, &quot;, &quot;, &quot;hello&quot;, &quot;!&quot;]} iex&gt; Pinyin.read(&quot;Ni3hao3!&quot;, :mixed) {:ok, [%Pinyin{tone: 3, word: &quot;Ni&quot;}, %Pinyin{tone: 3, word: &quot;hao&quot;}, &quot;!&quot;]} iex&gt; Pinyin.read(&quot;Ni3hao3, hello!&quot;, :mixed) {:ok, [%Pinyin{tone: 3, word: &quot;Ni&quot;}, %Pinyin{tone: 3, word: &quot;hao&quot;}, &quot;, &quot;, %Pinyin{word: &quot;he&quot;}, &quot;llo&quot;, &quot;!&quot;]} iex&gt; Pinyin.read(&quot;Ni3好hao3, hello!&quot;, :mixed) {:ok, [%Pinyin{tone: 3, word: &quot;Ni&quot;}, &quot;好&quot;, %Pinyin{tone: 3, word: &quot;hao&quot;}, &quot;, &quot;, %Pinyin{word: &quot;he&quot;}, &quot;llo&quot;, &quot;!&quot;]}When :mixed or :word mode is used, it is possible some words are incorrectly identified as pinyin. This is generally not a problem for users who just wish to use marked/1 or numbered/1 on the result of read/2, since pinyin syllables with no tone are printed as is.Capitalization and -r suffixThis function is able to read capitalized and uppercase pinyin strings. That is, strings such as &quot;Ni3hao3&quot;, &quot;NI3HAO3&quot; and &quot;NI3hao3&quot; are accepted. However, pinyin words with mixed capitalization are not recognized:iex&gt; Pinyin.read(&quot;Hao3&quot;) {:ok, [%Pinyin{tone: 3, word: &quot;Hao&quot;}]} iex&gt; Pinyin.read(&quot;HAO3&quot;) {:ok, [%Pinyin{tone: 3, word: &quot;HAO&quot;}]} iex&gt; Pinyin.read(&quot;HaO3&quot;) {:error, &quot;HaO3&quot;}Finally, this function does not detect the -r suffix. Users of the library should take care to fully write out er instead. That is, do not write &quot;zher&quot;, use &quot;zheer&quot; instead.iex&gt; Pinyin.read(&quot;zher&quot;) {:error, &quot;zher&quot;} iex&gt; Pinyin.read(&quot;zheer&quot;) {:ok, [%Pinyin{word: &quot;zhe&quot;}, %Pinyin{word: &quot;er&quot;}]}","ref":"Pinyin.html#read/2","title":"Pinyin.read/2","type":"function"},{"doc":"Identical to read/2, but returns the result or a Pinyin.ParseErrorExamplesiex&gt; Pinyin.read!(&quot;ni3hao3&quot;) [%Pinyin{tone: 3, word: &quot;ni&quot;}, %Pinyin{tone: 3, word: &quot;hao&quot;}] iex&gt; Pinyin.read!(&quot;ni3 hao3&quot;) [%Pinyin{tone: 3, word: &quot;ni&quot;}, &quot; &quot;, %Pinyin{tone: 3, word: &quot;hao&quot;}] iex&gt; Pinyin.read!(&quot;ni 3&quot;) ** (Pinyin.ParseError) Error occurred when attempting to parse: `3`","ref":"Pinyin.html#read!/2","title":"Pinyin.read!/2","type":"function"},{"doc":"Sigil to create a pinyin list or struct.When used without any modifiers, this sigil converts its input into a pinyin list through the use of read!/2 in :exclusive mode. The w and m modifiers can be used to use :words or :mixed mode respectively.When this sigil is called with the s modifier, a pinyin struct is created by calling from_numbered/1.Examplesiex&gt; ~p/ni3/ [%Pinyin{tone: 3, word: &quot;ni&quot;}] iex&gt; ~p/ni3 hello/w [%Pinyin{tone: 3, word: &quot;ni&quot;}, &quot; &quot;, &quot;hello&quot;] iex&gt; ~p/ni3好/m [%Pinyin{tone: 3, word: &quot;ni&quot;}, &quot;好&quot;] iex&gt; ~p/ni3/s %Pinyin{tone: 3, word: &quot;ni&quot;}","ref":"Pinyin.html#sigil_p/2","title":"Pinyin.sigil_p/2","type":"macro"},{"doc":"List of pinyin syllables mixed with plain strings.","ref":"Pinyin.html#t:pinyin_list/0","title":"Pinyin.pinyin_list/0","type":"type"},{"doc":"Representation of a pinyin syllable.This struct represents a single syllable in pinyin. It stores a textual representation of the syllable without any tone marks. In this representation, ü is always stored as v. The tone of the syllable is stored in the tone field. 0 represents the neutral tone.Do not create a pinyin struct manually. Instead, use a function such as create/2, from_marked/1, from_numbered/1 or use the sigil_p/2 sigil.","ref":"Pinyin.html#t:t/0","title":"Pinyin.t/0","type":"type"},{"doc":"Error that may be raised by read!/2 or sigil_p/2","ref":"Pinyin.ParseError.html","title":"Pinyin.ParseError","type":"exception"}]